#pragma once

#include "ExtAPI_defines.h"

class CzVar
{
public:

	CzVar(void);
	CzVar(ZVAR hVar);
	~CzVar(void);

	virtual bool Attach(ZVAR hVar);
	ZVAR GetZVAR();

	bool Create(long VarID, const char* lpVarName = 0);

	bool GetByName(const char* lpVarName);
	
	bool Delete();
	void Release();

	const char* GetName();
	bool Rename(const char* lpNewName);

	long GetTypeID();
	bool GetTypeName(ZVAR hStringVar);
	bool IsType(long VarID);
	bool ReInit(long VarID);

	bool GetValue(long VarID, void* pValue);
	bool SetValue(long VarID, void* pValue);
	bool GetValueA(long VarID, ZSTR hStrVar);
	bool SetValueA(const char* lpValueText);

	bool CopyValue(ZVAR hVarSrc);

	void* GetDataPtr(long VarID);
	
	bool SetVarRef(ZVAR hSrcVar);
	
	bool EditUI(const char* lpPrompt = NULL);
	bool EditUI2(const char* lpPrompt = NULL, ZLIST hFlags = NULL);

	//Cast-to-ZVAR operator
	operator ZVAR () {
		return GetZVAR();
	}

protected:

	ZVAR m_hVar;
	bool m_AutoDelete;
};
