#ifndef __ZPROJECT_INCLUDED__
#define __ZPROJECT_INCLUDED__

#pragma once

// init state

bool zproj_IsInit();
bool zproj_Init();
bool zproj_Free();

// loading/saving project

bool zproj_LoadProject(const char* lpProjName);
bool zproj_SaveProject();		// project file and all unsaved maps
bool zproj_SaveProjectFile();	// just save the project file 
bool zproj_SaveProjectAs(const char* lpProjName);
bool zproj_DemandSave();

bool zproj_IsPathOK();
const char* zproj_GetProjectFilename();

// saving map

bool zproj_AutoSaveMap(const char* lpMapName);
bool zproj_AutoLoadMap(const char* lpMapName);

// settings and options

ZLIST	zproj_GetSettingsList();
bool	zproj_GetSetting(const char* lpName, long VarID, void* pValue);
bool	zproj_SetSetting(const char* lpName, long VarID, void* pValue);

bool	zproj_GetOpFlag(const char* lpOpName);
bool	zproj_SetOpFlag(const char* lpOpName, bool StateFlag);
bool	zproj_DelOpsFollowing(const char* lpOpName);

// accessing maps

ZLIST	zproj_GetMapList();
ZMAP	zproj_GetMap(const char* lpMapName);
ZMAP	zproj_CreateMap(const char* lpMapName);
ZMAP	zproj_GetOrCreateMap(const char* lpMapName);

bool	zproj_GetHeightfieldRange(float& minval, float& maxval);

bool	zproj_SetMapFlag(const char* lpMapName, long MapFlag, bool State);

// scale settings

long	zproj_GetCurTileSizeDM();
bool	zproj_SetCurTileSizeDM(long TileSizeDM);

float	zproj_GetCurHorizScaleHF();
bool	zproj_SetCurHorizScaleHF(float HorizScaleHF);

#endif